@ECHO OFF
CLS
TITLE Prepare Disk for WinNTSetup3
:PRIVILEGECHECK
NET SESSION >nul 2>&1
IF %errorlevel% == 0 (
GOTO SELECTTYPE
) else (
GOTO GETPRIVILEGE
)
:NOPRIVILEGE
ECHO        Prepare Hard Disks for WinNTSetup3 GPT or MBR
ECHO -----------------------------------------------------------
ECHO           Warning, Elevated Privilege is Required 
ECHO.                                       
ECHO                 RE-OPEN AS AN ADMINISTRATOR        
ECHO                  THE PROGRAM WILL NOW EXIT 
ECHO.
ECHO -----------------------------------------------------------
ECHO.
PAUSE
EXIT
:GETPRIVILEGE
SET "params=%*"
SETLOCAL EnableDelayedExpansion
CD /d "%~dp0" && ( IF EXIST "%temp%\getadmin.vbs" DEL "%temp%\getadmin.vbs" ) && fsutil dirty query %systemdrive% 1>NUL 2>NUL || (  ECHO Set UAC = CreateObject^("Shell.Application"^) : UAC.ShellExecute "cmd.exe", "/k CD ""%~sdp0"" && %~s0 %params%", "", "runas", 1 >> "%temp%\getadmin.vbs" && "%temp%\getadmin.vbs" && EXIT /B )
GOTO NOPRIVILEGE
:SELECTTYPE
ECHO Prepare Hard Disk for WinNTSetup3 GPT or MBR
ECHO --------------------------------------------
ECHO.
CHOICE /C MG /M "Are you setting up for MBR or GPT "
IF %ERRORLEVEL% == 1 GOTO INITMBR
IF %ERRORLEVEL% == 2 GOTO INITGPT
ECHO.
ECHO Invalid selection! Please choose a valid selection.
ECHO.
PAUSE
GOTO SELECTTYPE
EXIT
:INITMBR
CLS
ECHO Prepare Hard Disk for WinNTSetup3 (MBR)
ECHO --------------------------------------------
ECHO.
ECHO list disk >> list.txt
diskpart /s list.txt
DEL list.txt>nul
ECHO.
SET /p disk="Which disk number would you like to prepare? (e.g. 0): "
IF [%DISK%] == [] GOTO INITMBR
ECHO.
ECHO --WARNING-- This will FORMAT the selected disk and ERASE ALL DATA
ECHO.
ECHO You selected disk ---^> %disk%
ECHO.
CHOICE /C YN /M "Is this correct "
IF %ERRORLEVEL% == 1 GOTO INITMBR2
CLS
ECHO Preperation Aborted, No changes have been made...
ECHO.
PAUSE
EXIT
:INITMBR2
ECHO sel dis %disk% >> initmbr.txt
ECHO clean >>initmbr.txt
ECHO convert mbr >> initmbr.txt
ECHO cre par pri >> initmbr.txt
ECHO for quick fs=ntfs label="Windows" >> initmbr.txt
ECHO assign letter Q >> initmbr.txt
ECHO active >> initmbr.txt
ECHO exit >> initmbr.txt
:RUNMBR
CLS
diskpart /s initmbr.txt
DEL initmbr.txt >nul
ECHO.
ECHO This drive is now prepared for WinNTSetup3 - MBR\Legacy
ECHO.
ECHO The following drive letters have been assigned, and
ECHO will be automatically loaded into WinNTSetup3
ECHO.
ECHO Boot Drive----------: Q
ECHO Installation Drive--: Q
ECHO.
PAUSE
CD %~dp0
CD ..
START winntsetup_x64.exe /cfg:prep\preparedmbr.ini
EXIT
:INITGPT
CLS
ECHO Prepare Hard Disk for WinNTSetup3 (GPT)
ECHO --------------------------------------------
ECHO.
ECHO list disk >> list.txt
diskpart /s list.txt
DEL list.txt>nul
ECHO.
SET /p disk="Which disk number would you like to prepare? (e.g. 0): "
IF [%disk%] == [] GOTO INITGPT
ECHO.
ECHO --WARNING-- This will FORMAT the selected disk and ERASE ALL DATA
ECHO.
ECHO You selected disk ---^> %disk%
ECHO.
CHOICE /C YN /M "Is this correct "
IF %ERRORLEVEL% == 1 GOTO INITGPT2
CLS
ECHO Preperation Aborted, No changes have been made...
ECHO.
PAUSE
EXIT
:INITGPT2
ECHO select disk %disk% >> initgpt.txt
ECHO clean >> initgpt.txt
ECHO convert gpt >> initgpt.txt
ECHO cre par efi size=100 >> initgpt.txt
ECHO for quick fs=fat32 label="System" >> initgpt.txt
ECHO assign letter Q >> initgpt.txt
ECHO cre par msr size=16 >> initgpt.txt
ECHO cre par pri >> initgpt.txt
ECHO shrink minimum=450 >> initgpt.txt
ECHO for quick fs=ntfs label="Windows" >> initgpt.txt
ECHO assign letter R >> initgpt.txt
ECHO cre par pri >> initgpt.txt
ECHO for quick fs=ntfs label="WinRE" >> initgpt.txt
ECHO set id="de94bba4-06d1-4d40-a16a-bfd50179d6ac" >> initgpt.txt
:RUNGPT
CLS
diskpart /s initgpt.txt
DEL initgpt.txt >nul
ECHO.
ECHO This drive is now prepared for WinNTSetup3 - GPT\UEFI
ECHO.
ECHO The following drive letters have been assigned, and
ECHO will be automatically loaded into WinNTSetup3
ECHO.
ECHO Boot Drive----------: Q
ECHO Installation Drive--: R 
ECHO.
PAUSE
CD %~dp0
CD ..
START winntsetup_x64.exe /cfg:prep\preparedgpt.ini
EXIT